/*
 * myPutObj.cpp
 *
 *  Created on: Jul 1, 2014
 *      Author: nick
 */

#include "myPutObj.h"
#include <cctype>
#include <string>
#include "myS3Common.h"

using namespace std;


int myS3PutObjectDataCallback(int bufferSize, char *buffer, void *callbackData)
{
	FILE* stream = (FILE*)callbackData;
	return fread(buffer, 1, bufferSize, stream);
}


bool putObject(const std::string& strBucket, const std::string& strObj, const std::string& strPath, S3CannedAcl acl)
{
	uint64_t contentLength = 0;
	string strMD5;
	const char *cacheControl = 0, *contentType = 0, *md5 = 0;
	const char *contentDispositionFilename = 0, *contentEncoding = 0;
	int64_t expires = -1;
	S3CannedAcl cannedAcl = acl;
	int metaPropertiesCount = 1;
	S3NameValue metaProperties[S3_MAX_METADATA_COUNT] =
	{
			//{"x-amz-grant-full-control", "everyone"},
			{"x-amz-storage-class", "REDUCED_REDUNDANCY"},
			//{"x-amz-acl", "public-read-write"},

	};
	S3PutProperties putProperties =
	{
		contentType,
		md5,
		cacheControl,
		contentDispositionFilename,
		contentEncoding,
		expires,
		cannedAcl,
		metaPropertiesCount,
		metaProperties,
	};



	S3PutObjectHandler handler =
	{
			{
					&MyS3ResponsePropertiesCallback,
					&MyS3ResponseCompleteCallback
			},
			&myS3PutObjectDataCallback
	};
	bool bResult = false;
	MyS3Context myS3;
	S3BucketContext ctx;
	if (myS3.initialize(strBucket.c_str(), ctx))
	{
		if (getFileSize(strPath, contentLength))
		{
			if (calculateMD5Base64(strPath, strMD5))
			{
				putProperties.md5 = strMD5.c_str();
				string strExtent = getFileContentType(strPath);
				putProperties.contentType = strExtent.c_str();
				FILE*stream = fopen(strPath.c_str(), "r");
				if (stream)
				{
					S3_put_object(&ctx, strObj.c_str(), contentLength, &putProperties, NULL, &handler, stream);
					bResult = true;
					fclose(stream);
				}
			}
		}
	}

	return bResult;
}
